.. _deploy-to-ropsten:

Deploy Smart Contracts to Ropsten
==================================

Dependencies
~~~~~~~~~~~~

You must have Metamask Extension installed. 

Step 1 - Get Fake Ethers for your Account
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

1. Select Ropsten network in you MetaMask plugin.

.. image:: ../images/select_ropsten_network.png
  :width: 300

2. Navigate to `Ropsten Ethereum Faucet <https://faucet.ropsten.be/>`_ and enter your metamask first account address there 
to have ethers transferred in your account. 

.. image:: ../images/account_copied.png
  :width: 300

You can copy your account address from metamask like this,

.. image:: ../images/ropsten_faucet.png

3. After a few minutes, you’ll see ethers reflected in your account.

.. image:: ../images/ropsten_account_with_eth.png
  :width: 300


Step 2 - Create Infura project
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

1. Sign in to `Infura <https://infura.io/>`_.

2. Navigate to Etehereum from left pannel -> CREATE NEW PEOJECT.
Insert a name of the project and create one.

.. image:: ../images/create_infura_project.png
  :width: 300

3. Select "Ropsten" as the Endpoint under the Keys section. Copy the ``PROJECT ID``

.. image:: ../images/infura_project.png

4. Create a secret file

Note in the first line that we are loading the project id and mnemonic from a secrets.json file, 
which should look like the following, but using your own values. Make sure to .gitignore it! ::

    {
        "mnemonic": "planet auto sign choice ...",
        "projectId": "305c137050..."
    }

TIP: Instead of a secrets.json file, you can use whatever secret-management solution you like for your project. 
A popular and simple option is to use dotenv 48 for injecting secrets as environment variables.

We can now test out that this configuration is working by listing the accounts we have available for the Ropsten network. 
Remember that yours will be different, as they depend on the mnemonic you used. ::

    $ truffle console --network ropsten
    truffle(ropsten)> await web3.eth.getAccounts()
    [
    '0xABFf604B340Da8612F07b0d76ef54b2d2A8B611b',
    '0x3e4Cdd143b1C8FFb129Bb81f81B2B8835Ea03Cff',
    ...
    ]
    truffle(ropsten)> await web3.eth.getBalance('0xABFf604B340Da8612F07b0d76ef54b2d2A8B611b')
    '300000000000000000'

Step 3 - Truffle Configurations

Since we are using public nodes, we will need to sign all our transactions locally. 
We will use @truffle/hdwallet-provider to do this, setting it up with our mnemonic. 
We will also tell the provider how to connect to the test network by using the Infura endpoint.

Let’s start by installing the provider. ::

    install --save-dev @truffle/hdwallet-provider

``truffle-config.js`` ::

    const { projectId, mnemonic } = require('./secrets.json');
    const HDWalletProvider = require('@truffle/hdwallet-provider');

    module.exports = {

    networks: {
        development: {
            host: "127.0.0.1",     // Localhost (default: none)
            port: 8545,            // Standard Ethereum port (default: none)
            network_id: "*",       // Any network (default: none)
        },
        // Useful for deploying to a public network.
        // NB: It's important to wrap the provider as a function.
        ropsten: {
            provider: function() {
            return new HDWalletProvider(mnemonic, `https://ropsten.infura.io/v3/${projectId}`)
            },
            network_id: 3,
            gas: 4000000         // Any network (default: none)
        },
    };



Step 4 - Deploy smart contracts to Ropsten network
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

With a project configured to work on a public testnet, we can now finally deploy our contracts. 
The command here, other than specifying the network, is the same as if you were on your local development network, 
though it will take a few seconds to run as new blocks are mined. ::

    truffle migrate --network ropsten

results ::

    truffle migrate --reset --network ropsten

    Compiling your contracts...
    ===========================
    > Compiling ./contracts/BankLoan.sol
    > Compiling ./contracts/InsurancePolicy.sol
    > Compiling ./contracts/LoanPayment.sol
    > Compiling ./contracts/UserIdentity.sol
    > Artifacts written to /Users/...
    > Compiled successfully using:
    - solc: 0.8.1+commit.df193b15.Emscripten.clang



    Starting migrations...
    ======================
    > Network name:    'ropsten'
    > Network id:      3
    > Block gas limit: 8000000 (0x7a1200)


    1_initial_migration.js
    ======================

    Deploying 'Migrations'
    ----------------------
    > transaction hash:    0x259dfb43e9e14a41848f059113e6fd99a6d9dc440b268c6febbf36d04fdb7de4
    > Blocks: 0            Seconds: 10
    > contract address:    0x370832F91B4eEB027000ab863734fDE1e029AA55
    > block number:        11124774
    > block timestamp:     1632829881
    > account:             0xABFf604B340Da8612F07b0d76ef54b2d2A8B611b
    > balance:             0.299726975601985632
    > gas used:            248204 (0x3c98c)
    > gas price:           1.099999992 gwei
    > value sent:          0 ETH
    > total cost:          0.000273024398014368 ETH

    Pausing for 2 confirmations...
    ------------------------------
    > confirmation number: 1 (block: 11124775)
    > confirmation number: 2 (block: 11124776)

    > Saving migration to chain.
    > Saving artifacts
    -------------------------------------
    > Total cost:     0.000273024398014368 ETH


    2_user_identity_migration.js
    ============================

    Deploying 'UserIdentity'
    ------------------------
    > transaction hash:    0x2299788f194e9cfca030bbba6b3684358fa23d03c4d8da83c2ee9aa289365904
    > Blocks: 2            Seconds: 9
    > contract address:    0xeaA5fdB8018ba68896c8c44162D0a5A855EAedF6
    > block number:        11124779
    > block timestamp:     1632829976
    > account:             0xABFf604B340Da8612F07b0d76ef54b2d2A8B611b
    > balance:             0.295586883635859112
    > gas used:            3717807 (0x38baaf)
    > gas price:           1.099999991 gwei
    > value sent:          0 ETH
    > total cost:          0.004089587666539737 ETH

    Pausing for 2 confirmations...
    ------------------------------
    > confirmation number: 2 (block: 11124782)

    Deploying 'BankLoan'
    --------------------
    > transaction hash:    0xc47b0cd7b2beeee54bcc93edb4aabc7c43501579b41b068fcada97fc6d252a6c
    > Blocks: 2            Seconds: 9
    > contract address:    0x5950bC9fAcc343b8444c9461D9FF51013C475b64
    > block number:        11124785
    > block timestamp:     1632830017
    > account:             0xABFf604B340Da8612F07b0d76ef54b2d2A8B611b
    > balance:             0.291195553867796056
    > gas used:            3992118 (0x3cea36)
    > gas price:           1.099999992 gwei
    > value sent:          0 ETH
    > total cost:          0.004391329768063056 ETH

    Pausing for 2 confirmations...
    ------------------------------
    > confirmation number: 1 (block: 11124786)
    > confirmation number: 2 (block: 11124787)

    Deploying 'InsurancePolicy'
    ---------------------------
    > transaction hash:    0xa9041bb0878deb78ff018a813684e212603b111e0d3bbedcde3746fc109713ed
    > Blocks: 2            Seconds: 53
    > contract address:    0x00104cdBB88Ccc46af3BeB145F86D555c95FFC85
    > block number:        11124789
    > block timestamp:     1632830058
    > account:             0xABFf604B340Da8612F07b0d76ef54b2d2A8B611b
    > balance:             0.288159240387118051
    > gas used:            2760285 (0x2a1e5d)
    > gas price:           1.099999993 gwei
    > value sent:          0 ETH
    > total cost:          0.003036313480678005 ETH

    Pausing for 2 confirmations...
    ------------------------------
    > confirmation number: 1 (block: 11124792)
    > confirmation number: 3 (block: 11124794)

    Deploying 'LoanPayment'
    -----------------------
    > transaction hash:    0x79dddd7523ebeac1c92483e4f5bfa1968220e2bc01dc52d6c8f4d4b0d508615d
    > Blocks: 3            Seconds: 65
    > contract address:    0xeA70A7C456A39b1c859F470a206b83c1fB767FeF
    > block number:        11124797
    > block timestamp:     1632830192
    > account:             0xABFf604B340Da8612F07b0d76ef54b2d2A8B611b
    > balance:             0.285109574009297443
    > gas used:            2772424 (0x2a4dc8)
    > gas price:           1.099999992 gwei
    > value sent:          0 ETH
    > total cost:          0.003049666377820608 ETH

    Pausing for 2 confirmations...
    ------------------------------
    > confirmation number: 1 (block: 11124800)
    > confirmation number: 2 (block: 11124801)

    > Saving migration to chain.
    > Saving artifacts
    -------------------------------------
    > Total cost:     0.014566897293101406 ETH


    3_micro_token_migration.js
    ==========================

    Deploying 'MicroToken'
    ----------------------
    > transaction hash:    0x082fd2bce39eb95178ab78588252c71a2d3d01eba4840264aa556b18ea275f3e
    > Blocks: 4            Seconds: 21
    > contract address:    0x17c591C75978E90786E581c683Bf596D94199db7
    > block number:        11124806
    > block timestamp:     1632830272
    > account:             0xABFf604B340Da8612F07b0d76ef54b2d2A8B611b
    > balance:             0.284313435814363777
    > gas used:            694949 (0xa9aa5)
    > gas price:           1.099999993 gwei
    > value sent:          0 ETH
    > total cost:          0.000764443895135357 ETH

    Pausing for 2 confirmations...
    ------------------------------
    > confirmation number: 1 (block: 11124809)
    > confirmation number: 2 (block: 11124810)

    > Saving migration to chain.
    > Saving artifacts
    -------------------------------------
    > Total cost:     0.000764443895135357 ETH


    Summary
    =======
    > Total deployments:   6
    > Final cost:          0.015604365586251131 ETH

Step 5 - Check availability
~~~~~~~~~~~~~~~~~~~~~~~~~~~

That’s it! Our contract instances will be forever stored in the testnet, and publicly accessible to anyone.

You can see your contract on a block explorer such as `Etherscan <https://etherscan.io/>`_. 
Remember to access the explorer on the testnet where you deployed your contract, such as `ropsten.etherscan.io <https://ropsten.etherscan.io/>`_ for Ropsten.

TIP: You can check out the contract we deployed in the example above, along with all transactions sent to it, `here <https://ropsten.etherscan.io/address/0xABFf604B340Da8612F07b0d76ef54b2d2A8B611b>`_.

You can also interact with your instance as you regularly would, either using truffle console, or programmatically using web3. ::

    $ truffle console --network ropsten
    truffle(ropsten)> micro = await MicroToken.deployed()
    truffle(ropsten)> (await micro.totalSupply()).toString()

Step 6 - Refer to Smart Contracts addreses in Ropsten network
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

This deployment information will record in the build files inside ``build\contracts\`` directory

Ex: ``MicroToken.json`` ::

    "networks": {
        "3": {
        "events": {},
        "links": {},
        "address": "0x17c591C75978E90786E581c683Bf596D94199db7",
        "transactionHash": "0x082fd2bce39eb95178ab78588252c71a2d3d01eba4840264aa556b18ea275f3e"
        },
        "5777": {
        "events": {},
        "links": {},
        "address": "0xe0F3B6602962630d182EC424FbfBAd24119988da",
        "transactionHash": "0x3f3d7ca9cf5be97e2899118d48e7c0e299ea5e5ea8800d8298a43f4b1b7c7114"
        }
    },

All React web applications configured to ``5777`` local blockchain. 
Now we are going to change the network to Ropsten and refer to the smart contract addresses in the Ropsten network.

1. Refer ``bank-web-application`` to Ropsten
open ``bank-web-app/stores/authContext.js`` navigate to ``Smart Contract Addresses``
change the ``5777`` value to ``3``. ::

    // Smart Contract Addresses
    const microTokenAddress = MicroTokenBuild.networks[3].address;
    const userIdentityAddress = UserIdentityBuild.networks[3].address;
    const bankLoanAddress = BankLoanBuild.networks[3].address;
    const loanPaymentAddress = LoanPaymentBuild.networks[3].address;

This will refer the smart contract adderesses of Ropsten network used in ``bank-web-app``

2. Refer ``insurance-web-application`` to Ropsten
open ``insurance-web-app/stores/authContext.js`` navigate to ``Smart Contract Addresses``
change the ``5777`` value to ``3``. ::

    // Smart Contract Addresses
    const insurancePolicyAddress = InsurancePolicyBuild.networks[3].address;
    const microTokenAddress = MicroTokenBuild.networks[3].address;
    const userIdentityAddress = UserIdentityBuild.networks[3].address;

This will refer the smart contract adderesses of Ropsten network used in ``insurance-web-app``

You may need more fake ETHERS to other accounts in MetaMask to use the system.

